︠42b0ec7d-411b-48af-ba67-6c7389cb49aai︠
%html
<h1><center><font face='Arial Black'> Koyama-Maurer-Okamoto-Vanstone (KMOV) </font></center></h1>
<h1><center> RSA-like Encryption Based on Elliptic Curves</center></h1>
︡56701cbd-455c-47f2-996c-c26fe168cf02︡{"done":true,"html":"<h1><center><font face='Arial Black'> Koyama-Maurer-Okamoto-Vanstone (KMOV) </font></center></h1>\n<h1><center> RSA-like Encryption Based on Elliptic Curves</center></h1>"}
︠17a8d4a4-5b2f-4a38-a1a4-d56df4318da4s︠
import numpy
import itertools
def ASCIIPad(Mess,Mod):
    K = []
    for letter in Mess:
        K.append(ord(letter))
    L = Mod.ndigits()
    l = len(K)
    y = ZZ(math.floor(L/3))
    count = 0
    padded = []
    buffer = ""
    for numChar in K:
        numChar+=100
        buffer+=str(numChar)
        count+=1
        if count==y:
            padded.append(ZZ(buffer))
            buffer = ""
            count = 0
    if len(buffer)>0:
        padded.append(ZZ(buffer))
    return padded

def ASCIIDepad(Number):
    N = "";
    n = Number.ndigits() % 3;
    if (n > 0):
        print("This is not a padded ASCII string\n");
    else:
        L = [((Number - (Number % (1000^i)))/1000^i)%1000 - 100 for i in range(Number.ndigits()/3)];
        for i in range(Number.ndigits()/3):
            N = chr(L[i]) + N;
    return(N);
def ECRAdd(Point1,Point2,Group):
    a = Group[0]
    b = Group[1]
    p = Group[2]
    if Point1!=[]:
        x1 = Point1[0]
        y1 = Point1[1]
    if Point2!=[]:
        x2 = Point2[0]
        y2 = Point2[1]
    if ZZ(mod(4*a^3 + 27*b^2, p)) == 0:
        print ("This is not an ellitpic curve")
    elif Point1!=[] and ZZ(mod(y1^2, p)) != ZZ(mod(x1^3 + a*x1 + b,p)):
        print ("Point 1 is not on the elliptic curve.")
    elif Point2!=[] and ZZ(mod(y2^2, p)) != ZZ(mod(x2^3 + a*x2 + b,p)):
        print ("Point 2 is not on the elliptic curve.")
    else:
        if Point1==[]:
            R=Point2
        elif Point2=={}:
            R=Point1
        else:
            if x1==x2 and 0==ZZ(mod(y1+y2,p)):
                R=[]
            elif x1==x2 and y1==y2:
                R=ECRDouble(Point1,Group)
                if R==True:
                    return(True)
            else:
                g=gcd(x1-x2,p)
                if (g>1):
                    print ("factor is {0}".format(g))
                    return(True)
                s=ZZ(mod((y1-y2)/(x1-x2),p))
                x=ZZ(mod(s^2-(x1+x2),p))
                y=ZZ(mod(s*(x1-x)-y1,p))
                R=[x,y]
    return R

︡49a4702b-75da-47d0-b7cd-44397a1c27f5︡{"done":true}
︠90ac010a-30cd-4b87-9627-909d505578e7s︠
def ECRDouble(Point,Group):
    a = Group[0]
    b = Group[1]
    p = Group[2]
    if Point!=[]:
        x1 = Point[0]
        y1 = Point[1]
        if ZZ(mod(4*a^3 + 27*b^2, p)) == 0:
            print ("This is not an ellptic curve")
        elif Point!= [] and ZZ(mod(y1^2,p))!= ZZ(mod(x1^3+a*x1+b,p)):
            print ("point to double not on elliptic curve")
        elif y1==0:
            R=[]
        else:
            g = gcd(y1,p)
            if g>1:
                print ("Factor is {0}".format(g))
                return True
            s = ZZ(mod((3*x1^2+a)/(2*y1),p))
            x = ZZ(mod(s^2-(x1+x1),p))
            y = ZZ(mod(s*(x1-x)-y1,p))
            R = [x,y]
    else:
        R=[]
    return R



︡a0ad243e-24b7-4f12-a0de-aaa9724314fa︡{"done":true}
︠942b0a3b-2d91-4949-9b44-be6a260d977b︠
def ECRTimes(Point,scalar,Group):
    ECIDENTITY = []
    if Point==ECIDENTITY or scalar ==0:
        return ECIDENTITY
    else:
        m = scalar
        pt = Point
        x = ECIDENTITY
        j=1
        while j<(scalar +1):
            if m%2==0:
                m = m/2
            else:
                m=(m-1)/2
                x=ECRAdd(x,pt,Group)
                if x==True:
                    return true
            if m==0:
                return x
            pt = ECRDouble(pt,Group)
            if pt==True:
                return true
            j+=1
︡206d837c-3fd2-405f-9cb6-6bfcd6615af4︡{"done":true}
︠70727cb4-a6e0-4d08-9989-d821f91e4d87s︠
def ECRInverse (Point, Group):
    if Point == []:
        return(Point)
    else:
        p = Group[2]
        x = Point[0]
        y = Point[1]
        return([x,(p - y) % p])
︡2c7b44aa-ece5-47f7-89c6-ac99e1da1ed5︡{"done":true}
︠b3d2656b-b82a-47f7-90e6-ef41ad976572si︠
%latex

\flushleft {\bf Example.} Encrypt the message "Information Security" using the KMOV public key \\
$n=6917257498733996147938371874633328816556752630891230167602750050663225392713827472369791$
$s=10008345747001$
︡6d66d99f-bd99-4980-a6a4-c419051a4344︡{"file":{"filename":"/tmp/tmps30mp50a.png","show":true,"text":null,"uuid":"fca12cff-8be4-4945-917c-b0d42b537eba"},"once":false}︡{"stdout":"\n"}︡{"done":true}
︠abb2d987-b1a5-405b-b3d6-8423b4675a29s︠
n=6917257498733996147938371874633328816556752630891230167602750050663225392713827472369791
s=10008345747001
t= 4117749622628666100756441055185740317505736625202292131017935879300104542402810720953433
print('Private Key:')
print('t=', t)
print('Public Key:')
print('n=', n)
print('s=', s)

︡2a2ada83-7953-4949-a35b-5af940d0c623︡{"stdout":"Private Key:\n"}︡{"stdout":"t= 4117749622628666100756441055185740317505736625202292131017935879300104542402810720953433\n"}︡{"stdout":"Public Key:\n"}︡{"stdout":"n= 6917257498733996147938371874633328816556752630891230167602750050663225392713827472369791\n"}︡{"stdout":"s= 10008345747001\n"}︡{"done":true}
︠485daec4-77ab-4032-8f5b-8fe80620f98cs︠
M="Information Security"
m=ASCIIPad(M,n)
print ('The padded ASCII version of the plaintext is:', m)
︡2f0ede72-a9b0-4efa-babb-2cbe67ef4ec1︡{"stdout":"The padded ASCII version of the plaintext is: [173210202211214209197216205211210132183201199217214205216221]\n"}︡{"done":true}
︠87092631-bb7e-4b87-a4fb-59e9c45d367cs︠

b=(1-m[0]^3) %n
E=[0,b,n]
print ('The elliptic curve group is:', E)
︡18ee73bd-1426-472b-890c-f55dfd25858d︡{"stdout":"The elliptic curve group is: [0, 3020530985299184291599609240714612842029478907414102977434017401106896368717353991604026, 6917257498733996147938371874633328816556752630891230167602750050663225392713827472369791]\n"}︡{"done":true}
︠81350517-e571-4f85-b97d-39d7e74792d0s︠
pt=[m[0],1]
c=ECRTimes(pt,s,E)
print('The ciphertext is:', c)
︡9a4064d1-87a1-4880-8e5c-8bfa8eee23ad︡{"stdout":"The ciphertext is: [1835449135407271122180175106020375488710177408875137798012322720564309179236753357104986, 6746005215820619885607422385239986394759560144857805498142475098742794305531869234326693]\n"}︡{"done":true}
︠5bdde763-2053-4720-a980-7fd1d0d7f718si︠
%latex
\flushleft {\bf Example.} Decrypt the ciphertext from the previous example using the private key $t= 4117749622628666100756441055185740317505736625202292131017935879300104542402810720953433$.
︡3a339afe-fa83-4d4c-a5ae-c4f95f7d31a5︡{"file":{"filename":"/tmp/tmp0lzCEn.png","show":true,"text":null,"uuid":"932f8beb-658a-4176-837e-4d055c3efc7f"},"once":false}︡{"stdout":"\n"}︡{"done":true}
︠c5c3188c-d2aa-4f08-ba30-8e58e41f3fb1s︠
B=(c[1]^2-c[0]^3) %n
ED=[0,B,n]
ptd=ECRTimes(c,t,ED)
ASCIIDepad(ptd[0])
︡f6ad8699-4ff1-4d0d-8cf6-7fd947464db4︡{"stdout":"'Information Security'\n"}︡{"done":true}









